require 'active_support/concern'

module NaranyaEcm::Behaviors
  module Localizable

    extend ActiveSupport::Concern

    included do
      # Delegar el acceso tipo "Enumerable":
      delegate :any?, to: :@attributes

      # Re-establece el acceso tipo Hash:
      delegate :[],   to: :@attributes
      delegate :[]=,  to: :@attributes
      self.site = "http://www.example.com"

      attribute_name = self.name.demodulize.underscore[0..-("_translations".length+1)]
      alias_method attribute_name.to_sym, :lookup
    end

    def locales
      @attributes.keys
    end
    alias_method :available_locales, :locales

    def lookup
      locale = ::I18n.locale
      if ::I18n.respond_to?(:fallbacks)
        lookup_result = @attributes[::I18n.fallbacks[locale].map(&:to_s).find{ |loc| @attributes.has_key?(loc) }]
      else
        lookup_result = @attributes[locale.to_s]
      end
      lookup_result = @attributes.present? ? @attributes.first[1] : nil unless lookup_result.present?
      lookup_result
    end

  end
end
