require 'active_support/concern'

module NaranyaEcm::Behaviors
  module Timestampable

    extend ActiveSupport::Concern

    included do
      [:created_at, :updated_at].each do |timestamp_name|
        attr_accessor timestamp_name
        
        define_method timestamp_name do
          unless instance_variable_get("@#{timestamp_name}".to_sym).respond_to? :strftime
            instance_variable_set(
              "@#{timestamp_name}".to_sym,
              instance_variable_get("@#{timestamp_name}".to_sym).to_s.to_datetime
            )
          end
          instance_variable_get("@#{timestamp_name}".to_sym)
        end
      end
    end

  end
end
