
module NaranyaEcm
  class DownloadAuthorization

    include NaranyaEcm.document_module
    include NaranyaEcm::Behaviors::Timestampable

    belongs_to :media_resource
    # validates :media_resource, presence: true
    
    field :expires_at,  type: DateTime, default: -> { 5.minutes.from_now }
    field :tokens,      type: Hash

    def authorized_url
      unless @authorized_url
        uri = URI(self.media_resource.downloadable_url)
        uri.query = self.tokens.map { |key, value| "#{key}=#{value}" }.join '&'
        @authorized_url = uri.to_s
      end
      @authorized_url
    end

    # validate :requested_media_resource_is_private
    # def requested_media_resource_is_private
    #   errors.add :media_resource, "must be private" unless self.media_resource.private?
    # end

    # validate :requested_media_resource_is_valid
    # def requested_media_resource_is_valid
    #   unless self.media_resource.valid?
    #     errors.add :media_resource, self.media_resource.errors.messages
    #   end
    # end
    
  end
end
