module NaranyaEcm

  class MediaProcess
  
    include NaranyaEcm.document_module
    include NaranyaEcm::Behaviors::Timestampable

    # Template id
    field :template_id, type: String
    validates :template_id, presence: true

    # Source Media Resource:
    belongs_to :media_resource

    # Profile used as base:
    belongs_to :media_profile

    field :notify_url, type: String

    field :append_media_roles, type: Array, default: -> { [] }

    def template_hash
      ActiveSupport::JSON.decode template
    end

    def template_hash=(hash = {})
      self.template = ActiveSupport::JSON.encode hash
    end
    
  end
  
end