module NaranyaEcm
  class MediaProfile
  
    include NaranyaEcm.document_module
    include NaranyaEcm::Behaviors::Timestampable

    # Profile name
    field :name, type: String
    validates :name, presence: true

    # Title, Human readable name
    field :title, type: String

    # Preset id to use
    field :preset_id, type: String

    # Template content
    field :template, type: Hash

    # Append Media Roles
    field :append_media_roles, type: Array, default: -> { [] }
        
  end

end