module NaranyaEcm

  class Notification
  
    include ActiveModel::Model
    include ActiveModel::Serialization

    def attributes
      @attributes
    end

    def initialize_with_attributes_hash(attribs = {})
      @attributes = attribs
    end

    alias_method_chain :initialize, :attributes_hash

    def process
      NContent::SDK.logger.debug "NaranyaEcm::Notification: #{self.attributes}"
      NContent::SDK.logger.debug "NaranyaEcm::Notification: No processing implemented."
    end

    def method_missing(method, *args, &block)
      if method =~ /\A(\w+)=\z/i
        @attributes[$1.to_sym] = args.first
      elsif method =~ /\A(\w+)\z/i
        @attributes[$1.to_sym]
      else
        super # You *must* call super if you don't handle the
              # method, otherwise you'll mess up Ruby's method
              # lookup.
      end
    end

    def self.process(given_attributes)
      notification = self.new given_attributes
      notification.process
    end
    
    NContent::SDK.config.notification_processing_modules.each do |module_name|
      processing_module = module_name.safe_constantize
      include processing_module if processing_module.present?
    end

  end
  
end