require 'naranya_ecm/rest/errors'

module NaranyaEcm::Rest

  module FinderMethods

    def find(*args)
      case args.length
      when 0
        raise ResourceNotFound, "Couldn't find #{self.name} without an ID"
      when 1
        find_one(args.first)
      else
        self.where(id: args)
      end
    end

    protected

      def find_one(id)
        found_resource = self._load_from_fetched_attributes fetch_one(id)
        found_resource.instance_variable_set("@new_resource", false)
        found_resource
      end

      def fetch_one(id)
        NContent::SDK::RESTClient.get("#{path}/#{id}.json").body
      end
  end
end
