require 'active_support/concern'
module NaranyaEcm::Search
  module Methods
    extend ActiveSupport::Concern

    included do
      attr_reader :search_score, :search_order
    end
    
    def merge_search_hit_data(hit)
      @search_score, @search_order = hit.score, hit.order
    end

    module ClassMethods
      def search(*args)
        Results.new(self, *args)
      end
      def kick_search(terms, options={})
        search(Query.build_searchkick_like(terms, options))
      end
    end

  end
end
