module NContent
  module SDK
    module FaradayMiddleware

      # Adds the required response format to the request parameters, in order for
      # the SDK to work:
      class RequestBodyOnEnvironment < Faraday::Middleware

        def call(request_env)

          # Evitar en peticiones a '/oauth/token' y cuando no exista body.
          # Típicamente las peticiones GET no tienen body:
          if request_env.url.path != '/oauth/token' && request_env.respond_to?(:body) && request_env.body.present?
            request_body = request_env.body
          end

          @app.call(request_env).on_complete do |response_env|
            response_env[:request_body] = request_body if request_body.present?
          end
        end

      end
    end
  end
end
