require "benchmark"

module NContent
  module SDK
    module FaradayMiddleware
      # Parses the responses to models:
      class ResponseParser < Faraday::Middleware

        def call(request_env)
          # do something with the request
          # request_env[:request_headers].merge!(...)

          @app.call(request_env).on_complete do |response_env|
            
            unless request_env.url.path =~ /\A\/oauth/i ||
                   response_env.response_headers["Content-Type"] !~ /\Aapplication\/json/i ||
                   response_env.body.strip.empty?

              benchmark = Benchmark.measure "api_response_parsing" do
                # replace body with parsed_data:
                response_env[:body] = ActiveSupport::JSON.decode(
                  response_env[:body]
                )
              end

              response_env[:ncontent_api_response_parsing_tms] = benchmark

            end
          end
        end

      end
    end
  end
end
