# -*- encoding : utf-8 -*-

module NContent
  module SDK

    class Railtie < Rails::Railtie

      def self.app_name
        Rails.application.railtie_name.sub(/_application$/, '')
      end

      initializer "ncontent.configure_rails" do

        config_from_yaml = NContent::SDK.config.parse_yaml(
          Rails.root.join('config/ncontent.yml').to_s
        ) || NContent::SDK.config.parse_yaml(
          Rails.root.join('config/naranya_ecm.yml').to_s
        ) || {}

        if config_from_yaml.key? Rails.env
          config_from_yaml = config_from_yaml[Rails.env]
        end

        # config from whatever was parsed or not:
        NContent::SDK.configure config_from_yaml

        # Setup the logger:
        NContent::SDK.logger = Rails.logger

        # Setup the cache:
        NContent::SDK.cache = Rails.cache

      end

      config.after_initialize do
        # Try to initialize a token (from cache or from nContent), just in case
        # all threads start to go medieval asking for tokens at nContent:
        # begin
        #   NContent::SDK::RESTClient.oauth_token
        # rescue => e
        #   Rails.logger.warn "NContent SDK OAuth token test failed on app after_initialize"
        # end
      end

      rake_tasks do
      end

      generators do
      end

    end
  end
end
